<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>insertUser</title>
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <div class="container bg-light">
      <h2 class="text-center">Thêm User mới</h2>
      <div class="row">
        <div class="col-md-6 mx-auto">
          <div class="form-group">
            <label for="inp-first-name">First Name</label>
            <input
              type="text"
              class="form-control"
              name="firstname"
              id="inp-first-name"
              placeholder="nhập firstname"
            />
          </div>
          <div class="form-group">
            <label for="inp-last-name">last Name</label>
            <input
              type="text"
              class="form-control"
              name="firstname"
              id="inp-last-name"
              placeholder="nhập lastname"
            />
          </div>
          <div class="form-group">
            <label for="select-customer-type">Country</label>
            <div class="form-group">
              <select class="form-control" id="select-country">
                <option value="VN">Việt Nam</option>
                <option value="USA">USA</option>
                <option value="AUS">AUS</option>
                <option value="CAN">CAN</option>
              </select>
            </div>
          </div>
          <div class="form-group">
            <label for="select-customer-type">Country Type</label>
            <div class="form-group">
              <select
                class="form-control"
                name="customerType"
                id="select-customer-type"
              >
                <option value="Standard">Standard</option>
                <option value="Gold">Gold</option>
                <option value="Premium">Premium</option>
              </select>
            </div>
          </div>
          <div class="form-group">
            <label for="tarea-subject">Subject</label>
            <textarea
              name="subject"
              class="form-control"
              id="tarea-subject"
              rows="3"
              placeholder="Nhập vào subject"
            ></textarea>
          </div>
          <div class="form-group">
            <a href="listUsers.html" id="btn-previous-page" class="btn btn-link"
              >quay lại</a
            >
            <button
              name="btnAddUser"
              id="btn-add-user"
              class="btn btn-success float-right"
            >
              Thêm mới
            </button>
          </div>
        </div>
      </div>
    </div>
    <script>
      $(document).ready(function () {
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gREQUEST_STATUS_CREATE_OK = 201;
        const gREQUEST_STATUS_DELETE_OK = 204;
        const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";

        //Xử lý nút Update
        $("#btn-add-user").on("click", function () {
          //khai báo đối tượng
          var vDataObj = {
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: "",
          };
          //1.Thu thập dữ liệu
          thuThapData(vDataObj);
          //2.Validate
          var vDuLieuHopLe = kiemTraData(vDataObj);
          if (vDuLieuHopLe) {
            //3.Gọi API
            goiAPIInsertData(vDataObj);
          }
        });

        //Hàm thu thập dữ liệu
        function thuThapData(vUpdateUserObj) {
          var vFirstnameInput = $("#inp-first-name");
          var vLastnameInput = $("#inp-last-name");
          var vSubjectInput = $("#tarea-subject");
          var vCountrySelect = $("#select-country"); // Corrected ID
          var vCustomerSelect = $("#select-customer-type"); // Corrected ID

          vUpdateUserObj.firstname = vFirstnameInput.val();
          vUpdateUserObj.lastname = vLastnameInput.val();
          vUpdateUserObj.subject = vSubjectInput.val();
          vUpdateUserObj.country = vCountrySelect.val(); // Corrected ID
          vUpdateUserObj.customerType = vCustomerSelect.val(); // Corrected ID
        }
        //Hàm validate
        function kiemTraData(paramUserObj) {
          if (paramUserObj.firstname == "") {
            alert("Bạn chưa nhập First name");
            return false;
          }
          if (paramUserObj.lastname == "") {
            alert("Bạn chưa nhập Last name");
            return false;
          }
          if (paramUserObj.subject == "") {
            alert("Bạn chưa nhập Subject");
            return false;
          }
          if (paramUserObj.country == "") {
            alert("Bạn chưa nhập country");
            return false;
          }
          if (paramUserObj.customerType == "") {
            alert("Bạn chưa nhập Customer type");
            return false;
          }
          return true;
        }

        //Hàm gọi API
        function goiAPIInsertData(paramOrderObj) {
          //Lấy dữ liệu User dựa vào UserId

          //Gọi API
          $.ajax({
            url: gBASE_URL,
            type: "POST",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(paramOrderObj),
            success: function (response) {
              xuLyHienThiTaoUser(response);
            },
            error: function (paramError) {
              alert(paramError.responseText);
            },
          });
        }

        function xuLyHienThiTaoUser(response) {
          console.log(response);
          alert("Tạo User Thành công");
          window.location.href = "./listUsers.html";
        }
      });
    </script>
  </body>
</html>
